﻿using System;
//Cal afegir manualment la referencia System.Configuration per tractar el fitxer app.config i poder llegir els seus valors
using System.Configuration;
using System.IO.Ports;
using System.Threading;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet la comunicació amb la báscula utilitzant el port de comunicacions.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class Comunicacions_Bascula
    {
        public static SerialPort _serialPort;

        public static Boolean InitSerialPort()
        {
            Boolean bRetorn;
            bRetorn = true;

            try
            {
                String nomPort = ConfigurationManager.AppSettings["PORT_1"];

                if (_serialPort == null)
                {
                    _serialPort = new System.IO.Ports.SerialPort(nomPort);
                }

                if (_serialPort.IsOpen == false) //if not open, open the port
                {
                    _serialPort.BaudRate = Convert.ToInt32(ConfigurationManager.AppSettings["BAU_1"]);
                    _serialPort.DataBits = Convert.ToInt32(ConfigurationManager.AppSettings["NUMBITS_1"]);
                    _serialPort.StopBits = System.IO.Ports.StopBits.One;
                    _serialPort.Parity = System.IO.Ports.Parity.None;
                    _serialPort.Handshake = System.IO.Ports.Handshake.None;
                    _serialPort.ReadTimeout = 500000;
                    _serialPort.WriteTimeout = 500000;
                    _serialPort.Open();

                    if (_serialPort.IsOpen == true)
                    {
                        bRetorn= true;
                    }
                    else
                    {
                        bRetorn = false;
                    }
                }
                return bRetorn;
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
                return bRetorn;
            }
        }


        public static Boolean CloseSerialPort()
        {
            Boolean bRetorn;
            bRetorn = true;

            if (_serialPort != null)
            {
                try
                {
                    _serialPort.DiscardInBuffer();
                    _serialPort.Close();
                    _serialPort.Dispose();
                    _serialPort = null;
                    bRetorn = true;
                }
                catch (Exception)
                {
                    bRetorn = false;
                }
            }
            return bRetorn;
        }


        public static String LecturaBufferBascula()
        {
            String buffer;
            buffer = "";

            try
            {
                buffer = _serialPort.ReadExisting();
                /*
                 * Lectura d'una linia del Buffer, l'enviament de les dades per part de la bàscula
                 * es de 20 caracters on el pes es troba a la posició 5 i té una longitud de 6 bytes
                 * la resta dels caracters de les posicions 1-4 i 12-20 tenen el valor 9
                 */
                Thread.Sleep(2000);

                if (_serialPort.BytesToRead > 0)
                {
                    buffer = _serialPort.ReadLine();
                    //En aquestes posicions es troba el pes del vehicle.
                    buffer = buffer.Substring(4, 6);
                }
                else
                {
                    string i = "";
                }

            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            return buffer;
        }
    }
}
