﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Security.Cryptography;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Clase que permet la creació d'una clau hash i encriptar el password de l'usuari
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GeneradorHash
    {
        public static Boolean VerificaClau(String textPerDesXifrar, String textPerXifrar)
        {
            String clauSaladaAmbHash = textPerDesXifrar;
            int quantitatDeSal = 4;
            Boolean bValor = true;

            // Extraure la sal
            Byte[] clauSaladaAmbHashBytes = Convert.FromBase64String(clauSaladaAmbHash);
            int sal = BitConverter.ToInt32(clauSaladaAmbHashBytes, 0);
            // Extraure el Hash sense la sal
            Byte[] clauHashBytes = new Byte[clauSaladaAmbHashBytes.Length - quantitatDeSal];
            Array.Copy(clauSaladaAmbHashBytes, quantitatDeSal, clauHashBytes, 0, clauHashBytes.Length);

            // Combina la clau de l'usuari i la sal
            byte[] clauDelUsuariBytes = Encoding.UTF8.GetBytes(textPerXifrar);
            byte[] salero = BitConverter.GetBytes(sal);
            byte[] clauSaladaAmbBytes = new byte[salero.Length + clauDelUsuariBytes.Length];
            Array.Copy(salero, 0, clauSaladaAmbBytes, 0, salero.Length);
            Array.Copy(clauDelUsuariBytes, 0, clauSaladaAmbBytes, salero.Length, clauDelUsuariBytes.Length);
            
            // Calcula el valor del Hash
            SHA1CryptoServiceProvider csp = new SHA1CryptoServiceProvider();
            byte[] clauAmbHash = csp.ComputeHash(clauSaladaAmbBytes);

            for (int ixByte = 0; ixByte < clauAmbHash.Length; ixByte++)
                {
                    if (clauAmbHash[ixByte] != clauHashBytes[ixByte])
                    {
                        bValor = false;
                    }
                    else                    
                    {
                        bValor = true;
                    }
                }

            return bValor;
        }
    }
}
