﻿using System;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Clase per ubicar les funcions de caracter general
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class General
    {
        //mètode per verificar que els valors siguin numèrics
        public static bool IsNumeric(string num)
        {
            try
            {
                double x = Convert.ToDouble(num);
                return true;
            }
            catch (Exception)
            {
                return false;
            }
        }

        public static String[,] CarregaTipusRegistre(String[,] aResultats)
        {
            aResultats[0, 0] = "PR";
            aResultats[0, 1] = null;
            aResultats[0, 2] = null;
            aResultats[1, 0] = "TR";
            aResultats[1, 1] = null;
            aResultats[1, 2] = null;
            aResultats[2, 0] = "AR";
            aResultats[2, 1] = null;
            aResultats[2, 2] = null;
            aResultats[3, 0] = "TU";
            aResultats[3, 1] = null;
            aResultats[3, 2] = null;
            aResultats[4, 0] = "PE";
            aResultats[4, 1] = null;
            aResultats[4, 2] = null;
            return aResultats;
        }

        public static int BuscaTipusRegistre(String sTipus, String[,] aResultats)
        {
            int iResult;
            iResult = 99;

            for (int i = 0; i < aResultats.GetLength(0);i++ )
            {
                if (aResultats[i, 0] == sTipus)
                {
                    iResult = i;
                    break;
                }
            }
            return iResult;
        }

        public static Boolean ComparaPasswords(String pw1, String pw2)
        {
            Boolean bResultat;
            bResultat = false;

            if ((pw1 != null && pw1 != "") && (pw2 != null && pw2 != ""))
            {
                if (pw1.Equals(pw2))
                    bResultat = true;
            }
            return bResultat;
        }
    }
}
