﻿using System;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer el CRUD amb la taula d'Articles amb les dades provinents de la lectura del fitxer de materies.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GestioArticles
    {
        public static Boolean GravarRegistre(String cTipus, Articulo artic)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

            Boolean bResultat;
            bResultat = true;
            switch (cTipus)
            {
                case "U":
                    if (client.ActualitzarArticle(artic.Codigo, artic.Descripcion,artic.Lugar_Descarga,artic.Numero_ID_TPC ,artic.Clase_Apartado_Letra))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "I":
                    if (client.AfegirArticle(artic))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "D":
                    if (client.EliminarArticle(artic.Codigo))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                default:
                    bResultat = false;
                    break;
            }
            return bResultat;
        }

        public static Boolean ConsultarRegistre(Articulo artic)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

            Boolean bResultat;
            bResultat = false;

            foreach (var q in client.ConsultarArticle(artic.Codigo))
            {
                if (q.Codigo != null)
                    bResultat = true;
            }
            return bResultat;
        }

    }
}
