﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer la lectura del fitxer provinent de l'aplicació MATERIES/PROVEIDORS
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GestioFitxersExterns
    {
        static StreamReader llegir;

        public static String[,] LlegirFitxerMat(String fitxer, String[,] aResultats)

        {
            String linia;
            String tipusDada;
            int nRegistres;
            Boolean bResult;

            nRegistres = 0;
            bResult = true;

            llegir = new StreamReader(fitxer);

            while(!llegir.EndOfStream)
            {
                linia = llegir.ReadLine();
                tipusDada = linia.Substring(17, 2);
                switch (tipusDada)
                {
                    case "PR":
                        Proveedor prov = new Proveedor();
                        prov.Fabrica = linia.Substring(0, 2);
                        prov.Codigo = linia.Substring(20, 5).ToString();
                        prov.Descripcion = linia.Substring(26, 50).ToString();
                        if (GestioProveidors.ConsultarRegistre(prov))
                        {
                            GestioProveidors.GravarRegistre("U", prov);
                        }else
                        {
                            prov.idUnico = Guid.NewGuid();
                            GestioProveidors.GravarRegistre("I", prov);
                        }
                        prov = null;
                        break;
                    case "TR":
                        Transportista trans = new Transportista();
                        trans.Fabrica = linia.Substring(0, 2);
                        trans.Codigo = linia.Substring(20, 5).ToString();
                        trans.Descripcion = linia.Substring(26, 50).ToString();
                        if (GestioTransportistes.ConsultarRegistre(trans))
                        {
                            GestioTransportistes.GravarRegistre("U", trans);
                        }else
                        {
                            trans.idUnico = Guid.NewGuid();
                            GestioTransportistes.GravarRegistre("I", trans);
                        }
                        trans = null;
                        break;
                    case "AR":
                        Articulo artic = new Articulo();
                        artic.Fabrica = linia.Substring(0, 2);
                        artic.Codigo = linia.Substring(20, 5).ToString();
                        artic.Descripcion = linia.Substring(26, 50).ToString();
                        if (GestioArticles.ConsultarRegistre(artic))
                        {
                            GestioArticles.GravarRegistre("U", artic);
                        }else
                        {
                            artic.idUnico = Guid.NewGuid();
                            GestioArticles.GravarRegistre("I", artic);
                        }
                        artic = null;
                        break;
                    case "TU":
                        Unidad ud = new Unidad();
                        ud.Fabrica = linia.Substring(0, 2);
                        ud.Codigo = linia.Substring(20, 5).Trim().ToString();
                        ud.Descripcion = linia.Substring(26, 50).Trim().ToString();
                        if (GestioTipusUnitat.ConsultarRegistre(ud))
                        {
                            GestioTipusUnitat.GravarRegistre("U", ud);
                        }else
                        {
                            ud.idUnico = Guid.NewGuid();
                            GestioTipusUnitat.GravarRegistre("I", ud);
                        }
                        ud = null;
                        break;
                    case "PE":
                        Pedido com = new Pedido();
                        com.Fabrica = linia.Substring(0, 2);
                        com.Pedido1 = linia.Substring(78, 6);
                        com.Linea_Pedido = linia.Substring(84, 2);
                        com.Proveedor = linia.Substring(86, 5);
                        com.Articulo = linia.Substring(96, 6);
                        com.Cantidad_Pedida = Convert.ToDouble(linia.Substring(102, 8));
                        com.Tipo_Unidad = linia.Substring(110, 2);
                        com.Tipo_Portes = linia.Substring(112, 1);
                        com.Numero_Albaran = linia.Substring(113, 10);
                        if(String.IsNullOrEmpty(linia.Substring (133,6).Trim()))
                        {
                            com.Numero_Bultos = null;
                        }
                        else
                        {
                            com.Numero_Bultos = Convert.ToDouble(linia.Substring(133, 6));
                        }
                        if (String.IsNullOrEmpty(linia.Substring(139, 10).Trim()))
                        {
                            com.Cantidad_Entregada = null;
                        }
                        else
                        {
                            com.Cantidad_Entregada = Convert.ToDouble(linia.Substring(139, 10));
                        }
                        if (GestioComandes.ConsultarRegistre(com))
                        {
                            GestioComandes.GravarRegistre("U", com);
                        }else
                        {
                            GestioComandes.GravarRegistre("I", com);
                        }
                        com = null;
                        break;
                    default:
                        bResult = false;
                        break;
                }
                int iIndexTrobat = General.BuscaTipusRegistre(tipusDada, aResultats);
                if (iIndexTrobat < 99)
                {
                    aResultats[iIndexTrobat,1] = true.ToString();
                    aResultats[iIndexTrobat, 2] = (Convert.ToDouble(aResultats[iIndexTrobat, 2]) + 1).ToString (); 
                }
                nRegistres++;
            }
            llegir.Close();
            return aResultats;
        }
    }
}
