﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer el CRUD de la taula de moviments.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GestioMoviments
    {
        public static Boolean DataSuperiorActual(String dData)
        {
            DateTime dt = Convert.ToDateTime(dData);
   
            DateTime dActual = Convert.ToDateTime(DateTime.Now.ToShortDateString()); 
            if (dt > dActual)
            {
                return false;
            }
            else
            {
                return true;
            }
        }


        public static Boolean GravarRegistre(String cTipus, Movimiento movim)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();
            Boolean bResultat;

            switch (cTipus)
            {
                case "U":
                    if (client.ActualitzarMoviment(movim.nMovim ,movim))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "I":
                    if (client.AfegirMoviment(movim))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "D":
                    if (client.EliminarMoviment(movim.nMovim))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                default:
                    bResultat = false;
                    break;
            }
            return bResultat;
        }

        public static int ProperNombreEntrada(DateTime dData)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

            return client.NombreEntradaDia(dData) + 1 ;
            
        }

        public static Boolean MovimentFusta(String tipus)
        {
            Boolean bResult;
            bResult = false;

            if(tipus == "ME" || tipus == "MN")
            {
                bResult=true;
            }
            return bResult;
        }

        public static Double CalculPromigDensitat(String wk1, String wk2, String wk3)
        {
            Double dResult;
            int nPesades;
            dResult = 0;
            nPesades = 0;

            if (!String.IsNullOrEmpty(wk1))
            {
                dResult = dResult + Convert.ToDouble(wk1);
                nPesades = nPesades + 1;
            }
            if (!String.IsNullOrEmpty(wk2))
            {
                dResult = dResult + Convert.ToDouble(wk2);
                nPesades = nPesades + 1;
            }
            if (!String.IsNullOrEmpty(wk3))
            {
                dResult = dResult + Convert.ToDouble(wk3);
                nPesades = nPesades + 1;
            }

            return Math.Round((dResult/nPesades)/1000);
        }
    }
}
