﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer el CRUD de la taula de tipus d'unitat.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GestioTipusUnitat
    {
        public static Boolean GravarRegistre(String cTipus, Unidad ud)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

            Boolean bResultat;
            bResultat = true;
            switch (cTipus)
            {
                case "U":
                    if (client.ActualitzarUnitatMesura(ud.Codigo, ud.Descripcion))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "I":
                    if (client.AfegirUnitatMesura(ud))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "D":
                    if (client.EliminarUnitatMesura(ud.Codigo))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                default:
                    bResultat = false;
                    break;
            }
            return bResultat;
        }

        public static Boolean ConsultarRegistre(Unidad ud)
        {
            ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

            Boolean bResultat;
            bResultat = false;

            foreach (var q in client.ConsultarUnitatMesura(ud.Codigo))
            {
                if (q.Codigo != null)
                    bResultat = true;
            }
            return bResultat;
        }

    }
}
