﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer el CRUD de la taula de Transportistes.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class GestioTransportistes
    {
        static ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

        public static Boolean GravarRegistre(String cTipus, Transportista trans)
        {
            Boolean bResultat;
            bResultat = true;
            switch (cTipus)
            {
                case "U":
                    if (client.ActualitzarTransportista(trans.Codigo, trans.Descripcion))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "I":
                    if (client.AfegirTransportista(trans))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                case "D":
                    if (client.EliminarTransportista(trans.Codigo))
                    {
                        bResultat = true;
                    }
                    else
                    {
                        bResultat = false;
                    }
                    break;
                default:
                    bResultat = false;
                    break;
            }
            return bResultat;
        }

        public static Boolean ConsultarRegistre(Transportista trans)
        {
            Boolean bResultat;
            bResultat = false;

            foreach (var q in client.ConsultarTransportista(trans.Codigo))
            {
                if (q.Codigo != null)
                    bResultat = true;
            }
            return bResultat;
        }


        public static String ConsultarTransportista(String trans)
        {
            String bResultat;
            bResultat = "";

            foreach (var q in client.ConsultarTransportista(trans))
            {
                if (q.Codigo != null)
                    bResultat = q.Descripcion;
            }
            return bResultat;
        }
    }
}
