﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ControlWeight.WCF;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Permet fer consultes referents al perfil d'usuari.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.BL
{
    public class PerfilUsuari
    {
        static ServiceReference1.ServicioControlWeightClient client = new ServiceReference1.ServicioControlWeightClient();

        public static String NomPerfilUsuari(String usuari)
        {
            try
            {
                String sPerfil = client.ConsultarPerfilUsuari(usuari);
                return sPerfil;
            }
            catch (Exception)
            {
                return null;
            }
        }

        public static String DescPerfilUsuari(String codiUnic)
        {
            String sResultat;
            sResultat = "";

            foreach (var q in client.ConsultarPerfil (codiUnic))
            {
                if (q.descripcio != null)
                    sResultat = q.descripcio;
            }
            return sResultat;
        }


        public static Guid CodiUnicPerfilUsuari(String usuari)
        {
            Guid sResultat;
            sResultat = new Guid();

            foreach (var q in client.ConsultarPerfil(usuari))
            {
                if (q.descripcio != null)
                {
                    sResultat = q.idu;
                }
            }
            return sResultat;
        }


        public static ArrayList LlistaMenusSegonsPerfil(String codiPerfil)
        {
            ArrayList _lstMenusSegonsPerfil = new ArrayList (client.ConsultarMenusSegonsPerfil(codiPerfil));

            return _lstMenusSegonsPerfil;
        }
    }
}
