﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using System.Runtime.Serialization;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Definició de tots els contractes que donaràn servei al projecte.
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.WCF
{
    [ServiceContract]

    interface IServicioControlWeight
    {
        #region Article

        [OperationContract]
        Boolean AfegirArticle(Articulo article);

        [OperationContract]
        Boolean EliminarArticle(string codArticle);

        [OperationContract]
        List<Articulo> LlistaArticles(string ordre);

        [OperationContract]
        List<Articulo> ConsultarArticle(String codArticle);

        [OperationContract]
        Boolean ActualitzarArticle(String codArticle, String sDescripcio, String codLlocDescarrega, String numID_TPC, String claseApartLletra);

        #endregion Article

        #region LlocDescarrega

        [OperationContract]
        Boolean AfegirLlocDescarrega(LugarDescarga llocDescarrega);

        [OperationContract]
        Boolean EliminarLlocDescarrega(String codiDescarrega);

        [OperationContract]
        List<LugarDescarga> LlistaLlocsDescarrega();

        [OperationContract]
        List<LugarDescarga> ConsultarLlocDescarrega(String codiDescarrega);

        [OperationContract]
        Boolean ActualitzarLlocDescarrega(String codiDescarrega, String sDescripcio);

        #endregion LlocDescarrega

        #region Matricula

        [OperationContract]
        Boolean AfegirMatricula(Matricula matricula);

        [OperationContract]
        Boolean EliminarMatricula(String matricula);

        [OperationContract]
        String[] LlistaMatricules();

        [OperationContract]
        String[] ConsultarMatricula(String matricula);

        [OperationContract]
        Boolean ActualitzarMatricula(Matricula matricula);

        #endregion Matricula

        #region Proveidor

        [OperationContract]
        Boolean AfegirProveidor(Proveedor proveidor);

        [OperationContract]
        Boolean EliminarProveidor(String codiProveidor);

        [OperationContract]
        List<Proveedor> LlistaProveidors(String ordre);

        [OperationContract]
        List<Proveedor> ConsultarProveidor(String codiProveidor);

        [OperationContract]
        Boolean ActualitzarProveidor(String codiProveidor, String sDescripcio);

        #endregion Proveidor

        #region Transportista

        [OperationContract]
        Boolean AfegirTransportista(Transportista transportista);

        [OperationContract]
        Boolean EliminarTransportista(String codTransportista);

        [OperationContract]
        List<Transportista> LlistaTransportistes(String ordre);

        [OperationContract]
        List<Transportista> ConsultarTransportista(String codTransportista);

        [OperationContract]
        Boolean ActualitzarTransportista(String codTransportista, String sDescripcio);

        #endregion Transportista

        #region UnitatsMesura

        [OperationContract]
        Boolean AfegirUnitatMesura(Unidad unitat);

        [OperationContract]
        Boolean EliminarUnitatMesura(String codUnitat);

        [OperationContract]
        List<Unidad> LlistaUnitatsMesura();

        [OperationContract]
        List<Unidad> ConsultarUnitatMesura(String codUnitat);

        [OperationContract]
        Boolean ActualitzarUnitatMesura(String codUnitat, String sDescripcio);

        #endregion UnitatsMesura

        #region Moviments

        [OperationContract]
        Boolean AfegirMoviment(Movimiento moviment);

        [OperationContract]
        Boolean EliminarMoviment(int numEntradaAnual);

        [OperationContract]
        List<Movimiento> ConsultarMoviment(int numEntradaAnual, DateTime dDataEntrada);

        [OperationContract]
        List<Movimiento> ConsultarMovimentsDia(DateTime sDataEnt);

        [OperationContract]
        List<Movimiento> ConsultarMovimentsDensimetre(DateTime sDataEnt);

        [OperationContract]
        Boolean ActualitzarMoviment(int numEntradaAnual, Movimiento moviment);
        
        [OperationContract]
        int NombreEntradaDia(DateTime movimDia);

        #endregion Moviments

        #region TipusCarrega

        [OperationContract]
        Boolean AfegirTipusCarrega(TipoCarga tipusCarrega);

        [OperationContract]
        Boolean EliminarTipusCarrega(String codiTipus);

        [OperationContract]
        List<TipoCarga> LlistaTipusCarrega();

        [OperationContract]
        List<TipoCarga> ConsultarTipusCarrega(String tipusCarrega);

        [OperationContract]
        Boolean ActualitzarTipusCarrega(String codiTipusCarrega, String sDescripcio);

        #endregion TipusCarrega

        #region Comandes

        [OperationContract]
        Boolean AfegirComanda(Pedido comanda);

        [OperationContract]
        Boolean EliminarComanda(String codiComanda);

        [OperationContract]
        List<Pedido> LlistaComandes();

        [OperationContract]
        List<Pedido> ConsultarComanda(Pedido comanda);

        #endregion Comandes

        #region Perfil

        [OperationContract]
        Boolean AfegirPerfil(Perfil perfil);

        [OperationContract]
        Boolean EliminarPerfil(String codiPerfil);

        [OperationContract]
        List<Perfil> LlistaPerfils();

        [OperationContract]
        List<Perfil> ConsultarPerfil(String codiPerfil);

        [OperationContract]
        String ConsultarPerfilUsuari(String usuari);

        [OperationContract]
        Boolean ActualitzarPerfil(String codiPerfil, String sDescripcio);

        [OperationContract]
        ArrayList ConsultarMenusSegonsPerfil(String codiPerfil);

        #endregion Perfil

        #region Usuario

        [OperationContract]
        Boolean AfegirUsuari(Usuario usuari);

        [OperationContract]
        Boolean EliminarUsuari(String codiUsuari);

        [OperationContract]
        List<Usuario> LlistaUsuaris();

        [OperationContract]
        List<Usuario> ConsultarUsuari(String codiUsuari);

        [OperationContract]
        Boolean ActualitzarUsuari(String codiUsuari, String sEMail, String sNom, Boolean bActiu, Guid sPerfil, String sPass);

        #endregion Usuario

    }
}
