﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Configuration;
using ControlWeight.BL;

/*
 * 	Author: 	J.Fàbregas
 *	Projecte:	Control del pes per a les entrades/sortides de vehicles amb Matèria Primera
 *	Objectiu:   Classe que permet fer el CRUD de les taula d'Articles, proveidors, comandes, tipus d'unitat, Transportistes
 *	Modificat:  Gener-2015
*/

namespace ControlWeight.WPF
{
    /// <summary>
    /// Lógica de interacción per frmCarregaDades.xaml
    /// </summary>
    public partial class frmCarregaDades : Window
    {
        String fitxerDadesMAT = ConfigurationManager.AppSettings["FILEHOST"].ToString();
        String directoriTreball = ConfigurationManager.AppSettings["DirFilesHost"].ToString();
        String[,] aResultats = new String[5, 3];

        public frmCarregaDades()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            image_lectura.Visibility = System.Windows.Visibility.Hidden;

            if (BL.GestioDirectoris.DirectoryExist(directoriTreball, fitxerDadesMAT))
            {
                tbFitHost.Text = String.Concat(directoriTreball, "\\", fitxerDadesMAT);
            }
        }


        private void btLoadDadesMAT_click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (tbFitHost.Text != "")
                {
                    aResultats = BL.General.CarregaTipusRegistre(aResultats);

                    System.IO.FileInfo info = new System.IO.FileInfo(tbFitHost.Text);
                    float midaFitxer = info.Length / 219f;
                    pbRegistres.Maximum = Convert.ToInt32(Math.Truncate(midaFitxer));

                    System.Windows.Threading.DispatcherTimer dispatcherTimer = new System.Windows.Threading.DispatcherTimer();
                    dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
                    dispatcherTimer.Interval = new TimeSpan(0, 0, 0, 0, Convert.ToInt32(Math.Round(midaFitxer) / 100));
                    dispatcherTimer.Start();

                    aResultats = BL.GestioFitxersExterns.LlegirFitxerMat(String.Concat(directoriTreball, "\\", fitxerDadesMAT), aResultats);
                    {
                        tbRegProv.Text = aResultats[0, 2];
                        tbRegTrans.Text = aResultats[1, 2];
                        tbRegArtic.Text = aResultats[2, 2];
                        tbRegUd.Text = aResultats[3, 2];
                        tbRegCom.Text = aResultats[4, 2];
                    }
                }
            }
            catch (Exception)
            {
                MessageBox.Show("Càrrega finalitzada AMB ERRORS", "Càrrega dades Matèries");                
            }
        }


        private void dispatcherTimer_Tick(object sender, EventArgs e)
        {
            pbRegistres.Value = pbRegistres.Value + 1 ;
            tbRegTotals.Text = (pbRegistres.Value).ToString();
            if (pbRegistres.Value >= pbRegistres.Maximum)
            {
                //int nReg = (Convert.ToInt32(aResultats[0, 2]) + Convert.ToInt32(aResultats[1, 2]) + Convert.ToInt32(aResultats[2, 2]) + Convert.ToInt32(aResultats[3, 2]) + Convert.ToInt32(aResultats[4, 2]));
                tbRegTotals.Text = (Convert.ToInt32(aResultats[0, 2]) + Convert.ToInt32(aResultats[1, 2]) + Convert.ToInt32(aResultats[2, 2]) + Convert.ToInt32(aResultats[3, 2]) + Convert.ToInt32(aResultats[4, 2])).ToString();
                image_lectura.Visibility = System.Windows.Visibility.Visible ;
            }
        }
    }
}
