﻿using System;
using System.Timers;
using System.Collections.Generic;
using System.Configuration;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Management;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ControlWeight.BL;
using ControlWeight.WCF;

namespace ControlWeight.WPF
{
    /// <summary>
    /// Lógica de interacción para DadesTransport.xaml
    /// </summary>
    public partial class frmDadesTransport : Window
    {
        BL.ServiceReference1.ServicioControlWeightClient client = new BL.ServiceReference1.ServicioControlWeightClient();

        public frmDadesTransport()
        {
            InitializeComponent();
        }

        #region clasesAuxiliars

        private Boolean NetegarFormulari(Boolean xCanviDia)
        {
            try
            {
                tbEntradaDia.Clear();
                tbEntradaAnual.Clear();
                tbHoraEntrada.Clear();
                tbHoraSortida.Clear();
                rbTipusMovim1.IsChecked = true;
                rbDespesesPagades.IsChecked = true;
                cbMatricula.SelectedValue = -1;
                cbMatricula.Text = "";
                cbTipusCarrega.SelectedValue = -1;
                cbTransportistes.SelectedValue = -1;
                cbProveidors.SelectedValue = -1;
                cbArticles.SelectedValue = -1;
                cbTipusUnitat.SelectedValue = -1;
                cbLlocsDescarrega.SelectedValue = -1;
                tbPesEntrada.Clear();
                tbPesSortida.Clear();
                tbPesNet.Clear();
                tbRemolc.Clear();
                tbTara.Clear();
                tbPesMaxim.Clear();
                tbComanda.Clear();
                tbNumAlbara.Clear();
                tbNumBultos.Clear();
                tbQuantitatEnt.Clear();
                tbQuantitatRebuda.Clear();
                tbObservacions.Clear();
                if (xCanviDia == true)
                {
                    dgMoviments.Items.Clear();
                    dgMoviments.ItemsSource = null;
                }
                else
                {
                    dgMoviments.SelectedValue = -1;
                }
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error netega formulari. " + ex.ToString());
                return false;
            }
        }


        private Boolean ActualitzaGridMoviments()
        {
            /*
             * 	Selecció de les dades marcades pel calendari, càrrega de la grid de moviments.
            */

            Boolean bRetorn;

            try
            {
                NetegarFormulari(true);
                dgMoviments.Items.Clear();
                dgMoviments.ItemsSource = null;
                calSortida.SelectedDate = calEntrada.SelectedDate;
                tbDataSortida.Text = ((DateTime)calSortida.SelectedDate).ToString("dd/MM/yyyy");
                bRetorn = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error inicialitzant Formulari Entrada Moviments. Error" + ex.ToString(), "Error inicalització");
                bRetorn = false;
            }

            try
            {
                if (GestioMoviments.DataSuperiorActual(String.Format(calEntrada.SelectedDate.ToString(), "d")) == false)
                {
                    MessageBox.Show("Selecció data entrada errònia.", "Data entrada", MessageBoxButton.OK, MessageBoxImage.Exclamation);
                    bRetorn = false;
                }
                else
                {

                    tbDataEntrada.Text = ((DateTime)calEntrada.SelectedDate).ToString("dd/MM/yyyy");

                    calEntrada.Visibility = System.Windows.Visibility.Hidden;

                    foreach (var q in client.ConsultarMovimentsDia((DateTime)calEntrada.SelectedDate))
                    {
                        dgMoviments.Items.Add(new
                        {
                            NumeroDoble = q.NumeroDia,
                            Numero_Anual = q.nMovim,
                            HoraEntrada = q.HoraEntrada,
                            HoraSalida = q.HoraSalida,
                            Matricula = q.Matricula,
                            TipoCarga = q.TipoCarga,
                            PesoEntrada = q.PesoEntrada,
                            PesoSalida = q.PesoSalida,
                            PesoNeto = q.Diferencia
                        });
                        bRetorn = true;
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error en la consulta dels moviments del dia seleccionat. Error" + ex.ToString(), "Error inicalització");
                bRetorn = false;
            }
            return bRetorn;
        }

        #endregion clasesAuxiliars


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            /* Inicialització del comboBox amb la informació que baixa del Host (Ordinador central) i que 
             No es pot eliminar, en qualsevol cas modificar i tenint en compte que serà una modificació
             temporal donat que la següent vegada que es carreguin les taules mestres, qualsevol modificació
             serà actualitzada amb les noves dades.
            */
            cbLlocsDescarrega.DisplayMemberPath = "Descripcion";
            cbLlocsDescarrega.SelectedValuePath = "Codigo";
            cbLlocsDescarrega.ItemsSource = client.LlistaLlocsDescarrega();

            cbTransportistes.DisplayMemberPath = "Descripcion";
            cbTransportistes.SelectedValuePath = "Codigo";
            cbTransportistes.ItemsSource = client.LlistaTransportistes("D");

            cbArticles.DisplayMemberPath = "Descripcion";
            cbArticles.SelectedValuePath = "Codigo";
            cbArticles.ItemsSource = client.LlistaArticles("D");

            cbProveidors.DisplayMemberPath = "Descripcion";
            cbProveidors.SelectedValuePath = "Codigo";
            cbProveidors.ItemsSource = client.LlistaProveidors("D");

            cbTipusCarrega.DisplayMemberPath = "Descripcion";
            cbTipusCarrega.SelectedValuePath = "Codigo";
            cbTipusCarrega.ItemsSource = client.LlistaTipusCarrega();

            cbTipusUnitat.DisplayMemberPath = "Descripcion";
            cbTipusUnitat.SelectedValuePath = "Codigo";
            cbTipusUnitat.ItemsSource = client.LlistaUnitatsMesura();


            /* Hi ha alguns controls que es canvien les seves propietats quan es carrega el formulari
             * poden treballar en temps de disseny però fent-los ocults en temps d'execució
             */
            calEntrada.Visibility = System.Windows.Visibility.Hidden;
            calSortida.Visibility = System.Windows.Visibility.Hidden;

            /* Hi ha alguns controls que tenen inicialitzacions per tal de facilitar la tasca a l'hora d'introduir
             * els movimients dels vehicles que entren a la fàbrica.
             */
            DateTime ent = new DateTime();
            ent = DateTime.Now;
            tbDataEntrada.Text = ent.ToString("dd/MM/yyyy");
            tbDataSortida.Text = DateTime.Now.ToString("dd/MM/yyyy");

            /*  Al canviar la data del control calendar, es dispara l'event "calEntrada_SelectedDatesChanged"
             *  Això farà que s'ompli la grid per defecte amb la data del dia
             *  Aprofitem també per posar la data seleccionada a la caixa de texte del dia d'entrada.
             */
            calEntrada.SelectedDate = Convert.ToDateTime(tbDataEntrada.Text);
            tbDataEntrada.Text = ((DateTime)calEntrada.SelectedDate).ToString("dd/MM/yyyy");

            calEntrada.Visibility = System.Windows.Visibility.Hidden;
        }

        private void btCalEntrada_Click(object sender, RoutedEventArgs e)
        {
            //Posa visible el calendari per escollir la data d'entrada
            calEntrada.Visibility = System.Windows.Visibility.Visible;
        }

        private void calEntrada_SelectedDatesChanged(object sender, SelectionChangedEventArgs e)
        {
            if (ActualitzaGridMoviments() == false )
            {
                MessageBox.Show("Error actualitzant graella moviments", "Error actualització");
            }

        }


        private void btCalSortida_Click(object sender, RoutedEventArgs e)
        {
            //Posa visible el calendari per escollir la data de sortida
            calSortida.Visibility = System.Windows.Visibility.Visible;
        }

        private void calSortida_SelectedDatesChanged(object sender, SelectionChangedEventArgs e)
        {
            /*Verificació utilitzant la capa BL (Business Layer) que la data de sortida de vehicles sigui sempre
             * mes petita o igual a la data del dia i mes gran o igual a la data d'entrada
            */
            if (GestioMoviments.DataSuperiorActual(String.Format(calSortida.SelectedDate.ToString(), "d")) == false)
            {
                MessageBox.Show("Selecció data sortida errònia.", "Data sortida", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
            else
            {
                tbDataSortida.Text = String.Format(calSortida.SelectedDate.ToString(), "d");
                calSortida.Visibility = System.Windows.Visibility.Hidden;
            }
        }


        private void dgMoviments_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                object item = dgMoviments.SelectedItem;
                if (item == null)
                {
                    return;
                }

                tbEntradaAnual.Text = (dgMoviments.SelectedCells[1].Column.GetCellContent(item) as TextBlock).Text;

                // Cerca informació corresponent a l'entrada anual
                foreach (var q in client.ConsultarMoviment(Convert.ToInt32(tbEntradaAnual.Text), (DateTime)calEntrada.SelectedDate))
                {
                    tbEntradaDia.Text = q.NumeroDia.ToString();
                    tbEntradaAnual.Text = q.nMovim.ToString();
                    tbHoraEntrada.Text = q.HoraEntrada;
                    tbHoraSortida.Text = q.HoraSalida;
                    if (q.Tipo_Camion == "E" || q.Tipo_Camion == null)
                    {
                        rbTipusMovim1.IsChecked = true;
                    }
                    else
                    {
                        rbTipusMovim2.IsChecked = true;
                    }
                    if (q.Tipo_Portes == null || q.Tipo_Portes == "P")
                    {
                        rbDespesesPagades.IsChecked = true;
                    }
                    else
                    {
                        rbDespesesDegudes.IsChecked = true;
                    }
                    cbMatricula.Text = q.Matricula;
                    cbTipusCarrega.SelectedValue = q.TipoCarga;
                    /*
                     * El tractament de gravació de targetes inductives solament es fa per les entrades dels
                     * camions que van al parc de fusta.
                     * El botó per llegir targetes sempre esta disponible per si s'han de fer comprovacions.
                     * */
                    if (cbTipusCarrega.SelectedValue != null)
                    {
                        if (BL.GestioMoviments.MovimentFusta(q.TipoCarga))
                        {
                            btTargetaInductiva.Visibility = System.Windows.Visibility.Visible;
                        }
                        else
                        {
                            btTargetaInductiva.Visibility = System.Windows.Visibility.Hidden;
                        }
                    }
                    cbTransportistes.SelectedValue = q.Transportista;
                    cbProveidors.SelectedValue = q.Proveedor;
                    cbArticles.SelectedValue = q.Articulo;
                    cbTipusUnitat.SelectedValue = q.Tipo_Unidad;
                    cbLlocsDescarrega.SelectedValue = q.Lugar_Descarga;
                    tbPesEntrada.Text = q.PesoEntrada.ToString();
                    tbPesSortida.Text = q.PesoSalida.ToString();
                    tbPesNet.Text = q.Diferencia.ToString();
                    tbRemolc.Text = q.Matricula_Remolque;
                    tbTara.Text = q.Tara.ToString();
                    tbPesMaxim.Text = q.PesoMaximo.ToString();
                    tbComanda.Text = q.Pedido;
                    tbNumAlbara.Text = q.Numero_Albaran;
                    tbNumBultos.Text = q.Numero_Bultos.ToString();
                    tbQuantitatEnt.Text = q.Cantidad_Entregada.ToString();
                    tbObservacions.Text = q.Comentarios;
                }

            }
            catch (Exception ex)
            {
                MessageBox.Show("Selecció dades errònies pel registre " + tbEntradaAnual.Text + " - " + ex.ToString());
            }
        }

        private void cbTipusCarrega_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (cbTipusCarrega.SelectedValue != null)
            {
                if (BL.GestioMoviments.MovimentFusta(cbTipusCarrega.SelectedValue.ToString()))
                {
                    btTargetaInductiva.Visibility = System.Windows.Visibility.Visible;
                }
                else
                {
                    btTargetaInductiva.Visibility = System.Windows.Visibility.Hidden;
                }
            }
        }


        private void btNetegar_Click(object sender, RoutedEventArgs e)
        {
            if (!NetegarFormulari(false))
            {
                MessageBox.Show("Error netega de formulari Bàscula");
            }
        }


        private void btGravar_Click(object sender, RoutedEventArgs e)
        {
            /*
             * 	Gravació de les dades existents, fent-ne totes les comprovacions necessaries.
             * 	per a la gravació de moviments, s'eixigeix que tots el camps estiguin cumplimentats.
            */
            try
            {
                String sTipusRegistre = "X";

                int numEntrada = GestioMoviments.ProperNombreEntrada(Convert.ToDateTime(calEntrada.SelectedDate));
                
                Movimiento movim = new Movimiento();

                if (tbEntradaDia.Text == null || tbEntradaDia.Text == "")
                {
                    sTipusRegistre = "I";
                    movim.NumeroDia = numEntrada;
                    movim.HoraEntrada = String.Format(DateTime.Now.ToString("HH:mm"));
                }
                else
                {
                    sTipusRegistre = "U";
                    movim.NumeroDia = Convert.ToInt32(tbEntradaDia.Text);
                    movim.nMovim = Convert.ToInt32(tbEntradaAnual.Text);
                    movim.HoraEntrada = tbHoraEntrada.Text;
                    movim.HoraSalida = tbHoraSortida.Text;
                }

                movim.Fabrica = ConfigurationManager.AppSettings["FABRICA"].ToString();
                movim.Fecha = Convert.ToDateTime(tbDataEntrada.Text);

                // Els moviments dels vehicles solament poden ser d'entrada o sortida
                if (rbTipusMovim1.IsChecked == true)
                {
                    movim.Tipo_Camion = "E";
                }
                else
                {
                    movim.Tipo_Camion = "S";
                }

                // Les despeses dels vehicles poden ser de ports pagats o be de ports deguts.
                if (rbDespesesPagades.IsChecked == true)
                {
                    movim.Tipo_Portes = "P";
                }
                else
                {
                    movim.Tipo_Portes = "D";
                }
                movim.Matricula = cbMatricula.Text;
                movim.TipoCarga = cbTipusCarrega.SelectedValue.ToString();
                movim.Transportista = cbTransportistes.SelectedValue.ToString();
                movim.Proveedor = cbProveidors.SelectedValue.ToString();
                movim.Articulo = cbArticles.SelectedValue.ToString();
                movim.Tipo_Unidad = cbTipusUnitat.SelectedValue.ToString();
                movim.Lugar_Descarga = cbLlocsDescarrega.SelectedValue.ToString();
                
                /* Per mantenir la coherencia i evitar errors, es verificaran les dades numèriques,
                 * en cas de blancs o null les dades es gravaran amb null.
                 */

                if (tbPesEntrada.Text != null && BL.General.IsNumeric(tbPesEntrada.Text))
                {
                    movim.PesoEntrada = Convert.ToDouble(tbPesEntrada.Text);
                }
                else
                {
                    movim.PesoEntrada = null;
                }
                if (tbPesSortida.Text != null && BL.General.IsNumeric(tbPesSortida.Text))
                {
                    movim.PesoSalida = Convert.ToDouble(tbPesSortida.Text);
                }
                else
                {
                    movim.PesoSalida = null;
                }
                if (tbPesNet.Text != null && BL.General.IsNumeric(tbPesNet.Text))
                {
                    movim.Diferencia = Convert.ToDouble(tbPesNet.Text);
                }
                else
                {
                    movim.Diferencia = null;
                }
                movim.Matricula_Remolque = tbRemolc.Text;
                if (tbTara.Text != null && BL.General.IsNumeric(tbTara.Text))
                {
                    movim.Tara = Convert.ToDouble(tbTara.Text);
                }
                else
                {
                    movim.Tara = null;
                }
                if (tbPesMaxim.Text != null && BL.General.IsNumeric(tbPesMaxim.Text))
                {
                    movim.PesoMaximo = Convert.ToDouble(tbPesMaxim.Text);
                }
                else
                {
                    movim.PesoMaximo = null;
                }
                movim.Numero_Albaran = tbNumAlbara.Text;
                if (tbNumBultos.Text != null && BL.General.IsNumeric(tbNumBultos.Text))
                {
                    movim.Numero_Bultos = Convert.ToDouble(tbNumBultos.Text);
                }
                else
                {
                    movim.Numero_Bultos = null;
                }

                if (tbQuantitatEnt.Text != null && BL.General.IsNumeric(tbQuantitatEnt.Text))
                {
                    movim.Cantidad_Entregada = Convert.ToDouble(tbQuantitatEnt.Text);
                }
                else
                {
                    movim.Cantidad_Entregada = null;
                }

                movim.Comentarios = tbObservacions.Text;

                if (GestioMoviments.GravarRegistre(sTipusRegistre, movim))
                {
                    tbEntradaDia.Text = movim.NumeroDia.ToString();
                    tbHoraEntrada.Text = movim.HoraEntrada.ToString();
                    if (movim.HoraSalida == null)
                    {
                        tbHoraSortida.Text = "";
                    }
                    else
                    {
                        tbHoraSortida.Text = movim.HoraSalida.ToString();
                    }
                    MessageBox.Show("Registre gravat correctament");
                    NetegarFormulari(true);
                    ActualitzaGridMoviments();
                    
                    }
                else
                {
                    MessageBox.Show("Gravació Registre Incorrecte");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Dades errònies o falten dades. " + ex.ToString());
            }
        }


        private void tbPesSortida_LostFocus(object sender, RoutedEventArgs e)
        {
            /*
             * Classe utilitzada per verificar inconsistències entre el pesos d'entrada i de sortida
             */
            if ((BL.General.IsNumeric(tbPesEntrada.Text) && tbPesEntrada != null) && (BL.General.IsNumeric(tbPesSortida.Text) && tbPesSortida != null))
            {
                if (Convert.ToDouble(tbPesSortida.Text) < Convert.ToDouble(tbPesEntrada.Text))
                {
                    tbPesNet.Text = (Convert.ToDouble(tbPesEntrada.Text) - Convert.ToDouble(tbPesSortida.Text)).ToString();
                    rbTipusMovim1.IsChecked = true;
                }
                else
                {
                    if (Convert.ToDouble(tbPesSortida.Text) > Convert.ToDouble(tbPesEntrada.Text))
                    {
                        tbPesNet.Text = (Convert.ToDouble(tbPesSortida.Text) - Convert.ToDouble(tbPesEntrada.Text)).ToString();
                        rbTipusMovim2.IsChecked = true;                        
                    }
                    else
                    {
                        tbPesNet.Text = "0";
                    }
                }
            }
        }


        private void btEliminar_Click(object sender, RoutedEventArgs e)
        {
            if (tbEntradaAnual.Text != null && tbEntradaAnual.Text != "")
            {
                Movimiento movim = new Movimiento();

                movim.Fabrica = ConfigurationManager.AppSettings["FABRICA"].ToString();
                movim.nMovim = Convert.ToInt32(tbEntradaAnual.Text);

                if (BL.GestioMoviments.GravarRegistre("D",movim))
                {
                    MessageBox.Show("Registre esborrat correctament");
                    NetegarFormulari(true);
                    ActualitzaGridMoviments();
                }
                else
                {
                    MessageBox.Show("Gravació Registre Incorrecte");
                }
            }

        }


        private void dgMoviments_CurrentCellChanged(object sender, EventArgs e)
        {
        }

        private void tbPesSortida_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (BL.General.IsNumeric(tbPesSortida.Text) && (tbHoraSortida.Text == null | tbHoraSortida.Text ==""))
            {
                tbHoraSortida.Text = String.Format(DateTime.Now.ToString("HH:mm"));
            }
        }


        private void btLecturaPesEntrada_Click(object sender, RoutedEventArgs e)
        {
            /* Connexió al port de comunicacions, es farà segons els paràmetres del app.config
             * permet recuperar automaticament el pes enviat per la bàscula al port de comunicacions
             */

            if (BL.Comunicacions_Bascula.InitSerialPort() == true)
            {
                lblConexio.Content = "Connectat";

                /* Lectura del resultat dels valor que envia la bàscula mitjançant el port de comunicacions
                 * que estigui definit.
                 */
                String resultat = BL.Comunicacions_Bascula.LecturaBufferBascula();
                if (resultat == "")
                {
                    tbPesEntrada.Text = "";
                }
                else
                {
                    tbPesEntrada.Text = (Convert.ToDouble(resultat)).ToString();
                }
            }
            else
            {
                lblConexio.Content = "NO Connectat";
            }

            BL.Comunicacions_Bascula.CloseSerialPort();

        }


        private void btnEnviar_Click(object sender, EventArgs e)
        {
            //if ((_serialPort != null) && (_serialPort.IsOpen == true))
            //    _serialPort.Write(tbComanda.Text.ToString());
        }

        private void btnConn_Click(object sender, RoutedEventArgs e)
        {
            /*
             * 	Permet fer una comprovació de connexió al port de comunicacions
             * 	i verificar-ne el seu funcionament.
            */
            if (BL.Comunicacions_Bascula.InitSerialPort() == true)
            {
                lblConexio.Content = "Connectat";
            }
            else
            {
                lblConexio.Content = "NO Connectat";
            }
        }

        private void btnDesConn_Click(object sender, RoutedEventArgs e)
        {
            /*
             * 	Permet fer una comprovació de connexió al port de comunicacions
             * 	i verificar-ne el seu funcionament.
             */
            if (BL.Comunicacions_Bascula.CloseSerialPort() == true)
            {
                lblConexio.Content = "Desconnectat";
            }
            else
            {
                lblConexio.Content = "Error Desconnexió";
            }
        }

        private void btTargetaInductiva_click(object sender, RoutedEventArgs e)
        {
            if (tbEntradaDia.Text == null || tbEntradaDia.Text == "")
            {
                int numEntrada = GestioMoviments.ProperNombreEntrada(Convert.ToDateTime(calEntrada.SelectedDate));
            }
            
            frmTargetaInductiva frmTI = new frmTargetaInductiva();
            frmTI.tbData.Text = tbDataEntrada.Text;
            frmTI.tbEntrada.Text = tbEntradaDia.Text;
            frmTI.tbMatricula.Text = cbMatricula.Text;
            frmTI.tbRemolc.Text = tbRemolc.Text;
            frmTI.ShowDialog();
        }



        private void calEntrada_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            calEntrada.Visibility = System.Windows.Visibility.Hidden;
        }

        private void calSortida_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            calSortida.Visibility = System.Windows.Visibility.Hidden;
        }

        private void btLecturaPesSortida_Click(object sender, RoutedEventArgs e)
        {
            /* Connexió al port de comunicacions, es farà segons els paràmetres del app.config
             * permet recuperar automaticament el pes enviat per la bàscula al port de comunicacions
             */

            if (BL.Comunicacions_Bascula.InitSerialPort() == true)
            {
                lblConexio.Content = "Connectat";

                /* Lectura del resultat dels valor que envia la bàscula mitjançant el port de comunicacions
                 * que estigui definit.
                 */
                String resultat = BL.Comunicacions_Bascula.LecturaBufferBascula();
                if (resultat == "")
                {
                    tbPesSortida.Text = "";
                }
                else
                {
                    tbPesSortida.Text = (Convert.ToDouble(resultat)).ToString();
                }
            }
            else
            {
                lblConexio.Content = "NO Connectat";
            }

            BL.Comunicacions_Bascula.CloseSerialPort();

        }

    }
}
