﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ControlWeight.BL;
//Capa que conté tots el serveis de la aplicació
using ControlWeight.WCF;

namespace ControlWeight.WPF
{
    /// <summary>
    /// Lógica de interacción para frmDensimetre.xaml
    /// </summary>
    public partial class frmDensimetre : Window
    {
        BL.ServiceReference1.ServicioControlWeightClient client = new BL.ServiceReference1.ServicioControlWeightClient();

        private Boolean NetegarFormulari(Boolean xCanviDia)
        {
            try
            {
                tbEntDia.Clear();
                tbMatricula.Clear();
                tbPesA1.Clear();
                tbPesA2.Clear();
                tbPesA3.Clear();
                tbPesI1.Clear();
                tbPesI2.Clear();
                tbPesI3.Clear();
                tbDens1.Clear();
                tbDens2.Clear();
                tbDens3.Clear();
                tbPromDensitat.Clear();
                ckDens.IsChecked = false;
                tbCodTrans.Clear();
                tbDescTrans.Clear();
                tbCodTC.Clear();
                tbDescTC.Clear();
                tbObsDens.Clear();

                if (xCanviDia == true)
                {
                    dgDensimetre.Items.Clear();
                    dgDensimetre.ItemsSource = null;
                }
                else
                {
                    dgDensimetre.SelectedValue = -1;
                }
                return true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error netega formulari. " + ex.ToString());
                return false;
            }
        }

        private Boolean ActualitzaGridDensimetre()
        {
            Boolean bRetorn;

            try
            {
                NetegarFormulari(true);
                dgDensimetre.Items.Clear();
                dgDensimetre.ItemsSource = null;
                bRetorn = true;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error inicialitzant Formulari Entrada Moviments. Error" + ex.ToString(), "Error inicalització");
                bRetorn = false;
            }

            try
            { 
                foreach (var q in client.ConsultarMovimentsDensimetre((DateTime)CalDensimetre.SelectedDate))
                {
                    int nPes;
                    nPes = 0;
                    if (!String.IsNullOrEmpty(q.Peso_Aire1.ToString()))
                    {
                        nPes = nPes + 1;
                    }
                    if (!String.IsNullOrEmpty(q.Peso_Aire2.ToString()))
                    {
                        nPes = nPes + 1;
                    }
                    if (!String.IsNullOrEmpty(q.Peso_Aire3.ToString()))
                    {
                        nPes = nPes + 1;
                    }
                    dgDensimetre.Items.Add(new
                    {
                        NumeroEntrada = q.NumeroDia,
                        HoraEntrada = q.HoraEntrada,
                        Matricula = q.Matricula,
                        TC = q.TipoCarga,
                        Transportista = q.Transportista,
                        Comentaris = q.Comentarios_Dens,
                        PesA1 = q.Peso_Aire1,
                        PesA2 = q.Peso_Aire2,
                        PesA3 = q.Peso_Aire3,
                        PesI1 = q.Peso_Inmersión1,
                        PesI2 = q.Peso_Inmersión2,
                        PesI3 = q.Peso_Inmersión3,
                        Dens1 = q.DensidadPesada1,
                        Dens2 = q.DensidadPesada2,
                        Dens3 = q.DensidadPesada3,
                        NumPesades = nPes.ToString()
                    });
                    bRetorn = true;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error en la consulta dels moviments del dia seleccionat. Error" + ex.ToString(), "Error inicalització");
                bRetorn = false;
            }
            return bRetorn;
        }


        public frmDensimetre()
        {
            InitializeComponent();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            /* Hi ha alguns controls que tenen inicialitzacions per tal de facilitar la tasca a l'hora d'introduir
             * els movimients dels vehicles que entren a la fàbrica.
             */
            //DateTime ent = new DateTime();
            //ent = DateTime.Now;
            //tbDataEntrada.Text = ent.ToString("dd/MM/yyyy");
        }


        private void CalDensimetre_SelectedDatesChanged(object sender, SelectionChangedEventArgs e)
        {
            if (ActualitzaGridDensimetre() == false)
            {
                MessageBox.Show("Error actualitzant graella densímetre", "Error actualització");
            }
        }

        private void dgDensimetre_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            try
            {
                object item = dgDensimetre.SelectedItem;
                if (item == null)
                {
                    return;
                }

                if (!NetegarFormulari(false))
                {
                    MessageBox.Show("Error inicialització formulari", "Error");
                    return;
                }

                tbEntDia.Text = (dgDensimetre.SelectedCells[15].Column.GetCellContent(item) as TextBlock).Text;
                tbMatricula.Text = (dgDensimetre.SelectedCells[0].Column.GetCellContent(item) as TextBlock).Text;

                tbPesA1.Text = (dgDensimetre.SelectedCells[5].Column.GetCellContent(item) as TextBlock).Text;
                tbPesA2.Text = (dgDensimetre.SelectedCells[6].Column.GetCellContent(item) as TextBlock).Text;
                tbPesA3.Text = (dgDensimetre.SelectedCells[7].Column.GetCellContent(item) as TextBlock).Text;
                tbPesI1.Text = (dgDensimetre.SelectedCells[8].Column.GetCellContent(item) as TextBlock).Text;
                tbPesI2.Text = (dgDensimetre.SelectedCells[9].Column.GetCellContent(item) as TextBlock).Text;
                tbPesI3.Text = (dgDensimetre.SelectedCells[10].Column.GetCellContent(item) as TextBlock).Text;
                tbDens1.Text = (dgDensimetre.SelectedCells[11].Column.GetCellContent(item) as TextBlock).Text;
                tbDens2.Text = (dgDensimetre.SelectedCells[12].Column.GetCellContent(item) as TextBlock).Text;
                tbDens3.Text = (dgDensimetre.SelectedCells[13].Column.GetCellContent(item) as TextBlock).Text;

                tbCodTrans.Text = (dgDensimetre.SelectedCells[3].Column.GetCellContent(item) as TextBlock).Text;
                tbDescTrans.Text = BL.GestioTransportistes.ConsultarTransportista(tbCodTrans.Text);
                tbCodTC.Text = (dgDensimetre.SelectedCells[14].Column.GetCellContent(item) as TextBlock).Text;
                tbDescTC.Text = BL.GestioTipusCarrega.ConsultarTipusCarrega(tbCodTC.Text);
                tbObsDens.Text = (dgDensimetre.SelectedCells[4].Column.GetCellContent(item) as TextBlock).Text;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Selecció dades errònies per la matricula " + tbMatricula.Text + " - " + ex.ToString());
            }
        }

        private void ckDens_Checked(object sender, RoutedEventArgs e)
        {
            tbPromDensitat.Text = (BL.GestioMoviments.CalculPromigDensitat(tbDens1.Text, tbDens2.Text, tbDens3.Text)).ToString();
        }

        private void ckDens_Unchecked(object sender, RoutedEventArgs e)
        {
            tbPromDensitat.Text = "";
        }
    }
}
