﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

//Capa que conté la lògica de negoci
using ControlWeight.BL;

namespace ControlWeight.WPF
{
    /// <summary>
    /// Lógica de interacción para Login.xaml
    /// </summary>
    public partial class Login : Window
    {
        public Boolean acceptat { get; set; }

        public Login()
        {
            InitializeComponent();
        }

        private void btEntrar_Click(object sender, RoutedEventArgs e)
        {
            acceptat = false;

            String sClauUsuari = BL.GestioUsuaris.ClauUsuari(tbUsuari.Text);

            if (sClauUsuari != null)
            {
                if (BL.GeneradorHash.VerificaClau(sClauUsuari, tbPassword.Password))
                {
                    acceptat = true;
                }
                else
                {
                    MessageBox.Show("Password incorrecte");
                    acceptat = false;
                }
            }
            else
            {
                MessageBox.Show("Identificació usuari incorrecte");
                acceptat = false; 
            }
            //Tanca la finestra de Login i retorna el control a la pantalla principal de l'aplicació
            DialogResult = true;
            //tbUsuari.Text = "";
            //tbPassword.Password = "";
        }

        private void lbRecordarPass_MouseEnter(object sender, MouseEventArgs e)
        {
            lbRecordarPass.Foreground = Brushes.Yellow;
        }

        private void lbRecordarPass_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (String.IsNullOrEmpty(tbUsuari.Text))
            {
                MessageBox.Show("Codi usuari inexistent", "Error usuari");
                tbUsuari.Focus();
            }
            else
            {
                String wk = BL.GestioUsuaris.ConsultaUsuari(tbUsuari.Text,"eMail");

                if (BL.GestioCorreu.RecordatoriClauUsuari(tbUsuari.Text, wk))
                {
                    MessageBox.Show("S'ha enviat un e-Mail recordant-li com recuperar la seva password", "Recordatori Password");
                }
                else
                {
                    MessageBox.Show("Hi ha dificultats per enviar el e-Mail recordant-li com recuperar la seva password", "Recordatori Password");
                }
            }
        }

        private void lbRecordarPass_MouseLeave(object sender, MouseEventArgs e)
        {
            lbRecordarPass.Foreground = Brushes.White;
        }

        private void btCancelar_Click(object sender, RoutedEventArgs e)
        {
            acceptat = false;
            //Tanca la finestra de Login i retorna el control a la pantalla principal de l'aplicació
            DialogResult = true;
        }

        private void lbCanviarPass_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (String.IsNullOrEmpty(tbUsuari.Text))
            {
                MessageBox.Show("Codi usuari inexistent", "Error usuari");
                tbUsuari.Focus();
            }
            else
            {
                String sClauUsuari = BL.GestioUsuaris.ClauUsuari(tbUsuari.Text);

                if (BL.GeneradorHash.VerificaClau(sClauUsuari, tbPassword.Password))
                {
                    frmUsuaris frmUS = new frmUsuaris();
                    //frmUS.tbIdUser.Text = tbUsuari.Text;
                    frmUS.sTipus = String.Concat("CP", tbUsuari.Text);
                    frmUS.ShowDialog();
                }
                else
                {
                    MessageBox.Show("Password incorrecte");
                }

            }
        }

        private void lbCanviarPass_MouseEnter(object sender, MouseEventArgs e)
        {
            lbCanviarPass.Foreground = Brushes.Yellow;
        }

        private void lbCanviarPass_MouseLeave(object sender, MouseEventArgs e)
        {
            lbCanviarPass.Foreground = Brushes.White;
        }
    }
}
