﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ControlWeight.BL;

namespace ControlWeight.WPF
{
    /// <summary>
    /// Lógica de interacción para frmTargetaInductiva.xaml
    /// </summary>
    public partial class frmTargetaInductiva : Window
    {
        String[] aResultats = new String[5];

        public frmTargetaInductiva()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            if (tbMatricula.Text == "" || tbEntrada.Text == "")
            {
                NetegaFormulari();
                btGravar.Visibility = System.Windows.Visibility.Hidden;
            }
            else
            {
                Random rdn = new Random();
                tbPalada.Text = rdn.Next(1, 9).ToString();
            }
        }

        private void btLlegir_Click(object sender, RoutedEventArgs e)
        {
            NetegaFormulari();
            btGravar.Visibility = System.Windows.Visibility.Hidden;
        }

        private void NetegaFormulari()
        {
            tbData.Clear();
            tbEntrada.Clear();
            tbMatricula.Clear();
            tbRemolc.Clear();
        }

        private void btGravar_Click(object sender, RoutedEventArgs e)
        {
            BL.Comunicacions_Densimetre.Targeta tg = new BL.Comunicacions_Densimetre.Targeta();
            
            tg.DataEntrada = tbData.Text;
            tg.Entrada = tbEntrada.Text;
            tg.Matricula = tbMatricula.Text;
            tg.Remolc = tbRemolc.Text ;
            tg.Palada = tbPalada .Text;

            /* Connexió al port de comunicacions, es farà segons els paràmetres del app.config
             * permet gravar la informació del vehicle que va a descarregar fusta als parcs
             */

            if (BL.Comunicacions_Bascula.InitSerialPort() == true)
            {
                tbVerificacio.Text = "Connectat";

                /* Resultat dels valor que envia el formulari al port de comunicacions
                 * que estigui definit per gravar la targeta d'acces al parc
                 */
                //aResultats = BL.Comunicacions_Densimetre.GravacioBufferTargeta(tg);
                //if (resultat == "")
                //{
                //    tbVerificacio.Text = "";
                //}
                //else
                //{
                //    tbVerificacio.Text = (Convert.ToDouble(resultat)).ToString();
                //}
            }
            else
            {
                tbVerificacio.Text = "NO Connectat";
            }

            BL.Comunicacions_Bascula.CloseSerialPort();

        }
    }
}
